package in.rootservers.accountancy.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.*;
import com.google.gwt.user.client.ui.RootPanel;
import org.vectomatic.dnd.DataTransferExt;
import org.vectomatic.dnd.DropPanel;
import org.vectomatic.file.File;
import org.vectomatic.file.FileList;

import java.util.List;


/**
 * Created by henrixd on 22.6.2015.
 */
public class Accountancy implements EntryPoint {

    private DropPanel dropZone = new DropPanel();

    //protected boolean useTypedArrays;
    protected List<File> readQueue;
    protected File fileHolder;
    //protected FileReader reader;

    public void onModuleLoad()
    {
        //useTypedArrays = !"false".equals(Window.Location.getParameter("typedArrays"));

        dropZone.setStyleName("dropZone");
        dropZone.addDragOverHandler(dragOverHandler);
        dropZone.addDragLeaveHandler(dragLeaveHandler);
        dropZone.addDropHandler(dropHandler);
        dropZone.addDragEnterHandler(dragEnterHandler);

        RootPanel.get("dropZone").add(dropZone);
    }

    private void processFiles(FileList files)
    {
        GWT.log("length="+files.getLength());
        for(File file : files)
        {
            GWT.log(file.getName());
            fileHolder = file; // No error.
            readQueue.add(file); // Error.
        }
        // start processing the queue
        readNextFile();
    }

    private void readNextFile()
    {
        GWT.log("readNextFile()");
        if (readQueue.size() > 0)
        {
            File file = readQueue.get(0);
            String type = file.getType();
            GWT.log(type);

            readQueue.remove(0);
            readNextFile();
        }
    }

    private DragOverHandler dragOverHandler = new DragOverHandler() {
        public void onDragOver(DragOverEvent event)
        {
            // For onDrop to work
            //GWT.log("onDragOver()");
            event.stopPropagation();
            event.preventDefault();
        }
    };

    private DropHandler dropHandler = new DropHandler()
    {
        public void onDrop(DropEvent event) {
            GWT.log("onDrop()");
            dropZone.removeStyleName("drag");
            processFiles(event.getDataTransfer().<DataTransferExt>cast().getFiles());
            event.stopPropagation();
            event.preventDefault();
        }
    };

    private DragEnterHandler dragEnterHandler = new DragEnterHandler() {
        public void onDragEnter(DragEnterEvent event)
        {
            dropZone.addStyleName("drag");
            GWT.log("onDragEnter()");
            event.stopPropagation();
            event.preventDefault();
        }
    };

    private DragLeaveHandler dragLeaveHandler = new DragLeaveHandler() {
        public void onDragLeave(DragLeaveEvent event) {
            dropZone.removeStyleName("drag");
            GWT.log("onDragLeave()");
            event.stopPropagation();
            event.preventDefault();
        }
    };
}
